laravel/routes/web.php
<?php

Route::redirect('/', 'login');

Route::view('email-test', 'email');

Auth::routes();

#Se redirecciona la ruta de registro a inicio de sesión
Route::redirect('register', 'login');

Route::view('under-construction', 'errors.under-construction')->name('under-construction');

Route::get('pdf-event', function(){

    $ticket = App\Ticket::first();

    return view('helpdesk.tickets.pdf.event', compact('ticket'));
});

#Rutas que requieren autenticación
Route::group(['middleware' => 'auth'], function () {


    Route::get('/home', 'DashboardController@index');


    Route::get('/', 'DashboardController@index')->name('home');
     

    #Notificaciones
    Route::get('notifications', 'NotificationsController@index')->name('notifications');
    Route::post('notification/{notification}/read', 'NotificationsController@read')->name('read-notification');
    Route::post('notification/archive', 'NotificationsController@destroy')->name('archive-notification');
    Route::get('notification/list-archive', 'NotificationsController@list_archive')->name('list-archive');


    #Busqueda avanzada
    Route::get('search', 'TicketController@advance_search')->name('advance-search');
    

    #Ticket
    Route::resource('tickets', 'TicketController');
    Route::post('tickets/archive', 'TicketController@archive_tickets')->name('archive-tickets');
    Route::get('ticket_list_archive', 'TicketController@list_archive')->name('list-archive-tickets');
    Route::get('tickets/{ticket}/show_deleted', 'TicketController@show_deleted')->name('show_deleted');
    Route::post('tickets/unarchive', 'TicketController@unarchive_tickets')->name('unarchive-tickets');
    Route::post('{ticket}/set-public-comment', 'TicketController@set_public_comment')->name('public-comment')->middleware('ticket_owner');
    // Route::post('{ticket}/set-internal-comment', 'TicketController@set_internal_comment')->name('internal-comment')->middleware('role:admin,agent,manager');
    Route::post('tickets/{ticket}/download', 'TicketController@to_pdf')->name('export_ticket_to_pdf');

    #Reabrir ticket
    Route::post('reopen_ticket/{ticket}', 'ReopenTicketController@reopen_ticket_action')->name('reopen_ticket')->middleware('role:company,agent');
    Route::get('read_reopen_ticket/{reopen_ticket}', 'ReopenTicketController@mark_reopen_ticket_as_read')->name('read_reopen_ticket');
    

    #Tareas
    Route::resource('tickets.tasks', 'TaskController')->only(['store', 'show', 'update', 'destroy']);
    Route::post('tickets/{ticket}/tasks/{tasks}/start_end_task', 'TaskController@start_end_task')->name('start-end-task');
    Route::get('tasks', 'TaskController@index')->name('agent-tasks')->middleware('role:agent');
    Route::post('tickets/{ticket}/tasks/{tasks}/reassing', 'TaskController@reassign')->name('reassing-task');
    Route::resource('tickets.tasks.events', 'TaskEventController');
    

    #Asignar proyecto
    Route::post('ticket/{ticket}/assign_to_project', 'ProjectTicketController@assign_ticket_to_project')->name('assign_to_project');

    #Departamentos
    Route::resource('departments', 'DepartmentController');
    Route::get('departments/{department}/agents', 'DepartmentController@get_department_agents')->name('get_department_agents');


    #Grupos de Departamentos
    Route::resource('departments.groups', 'DepartmentGroupController');
    

    #Agentes
    Route::resource('agents', 'AgentController');
    

    #Compañias
    Route::resource('companies', 'CompanyController');
    

    #Equipos
    Route::resource('companies.gears', 'GearController')->except(['create']);
    Route::resource('companies.gears.modules', 'GearModuleController');
    

    Route::post('insert/{module}/into/{gear}', 'GearModuleController@insert_module')->name('insert_module');
    Route::post('remove/{module}', 'GearModuleController@remove_module')->name('remove_module');


    Route::get('{type}/get-brands', 'GearController@get_brands')->name('get_brands');
    Route::get('{brand}/get-models', 'GearController@get_models')->name('get_models');
    Route::get('{company}/{model}/gears', 'GearController@get_gears_by_model')->name('get_gears_by_model');
    Route::post('reassing/{gear}', 'GearController@reassign_gear_to_zone')->name('reassign_gear_to_zone');
    Route::post('companies/{company}/gears/search', 'GearController@search_gear')->name('search_gear');
    Route::post('companies/{company}/gears/download', 'GearController@download_company_gear')->name('download_company_gear');


    #Zonas de compañias
    Route::resource('companies.zones', 'CompanyZonesController');
    
    
    #Tipos de contacto
    Route::resource('contact-types', 'CompanyUserTypeController');


    #Contactos de compañias
    Route::resource('companies.contacts', 'CompanyUserController');
    Route::get('{zone}/get_contacts', 'CompanyUserController@get_zone_contacts')->name('get_zone_contacts');


    #Catalogos de contacto
    Route::resource('companies.contact-catalogs', 'ContactCatalogController');


    #Zonas usuarios
    Route::resource('zoneusers', 'ZoneUserController');


    #Marcas de equipo
    Route::resource('brands', 'GearBrandController')->except(['create', 'edit']);
    

    #Agregar tipos de equipo a marcas
    Route::resource('brands.types', 'BrandTypeController');


    #Tipos de equipo
    Route::resource('types', 'GearTypeController')->except(['index', 'create', 'edit']);


    #Modelos de equipo
    Route::resource('brands.types.models', 'GearModelController')->except(['create', 'edit']);
    

    #Garantias
    Route::resource('warranties', 'WarrantyController');


    #Coberturas
    Route::resource('coverages', 'CoverageController');
    

    #Contratos
    Route::resource('contracts', 'ContractController');
    

    #Acuerdos se servicio (SLA)
    Route::resource('sla', 'SLAController');
    

    #Opciones ticket
    Route::resource('ticket-options', 'TicketOptionController');    


    #Estatus ticket
    Route::resource('status', 'StatusController');
    

    #Severidad ticket
    Route::resource('severity', 'SeverityController');
    

    #Categorias ticket
    Route::resource('category', 'CategoryController');
    Route::resource('category.subcategory', 'SubCategoryController');
    

    #Perfil 
    Route::resource('profile', 'ProfileController');
    

    #Directorio
    Route::resource('directory', 'DirectoryController');


    #Encuestas
    Route::resource('users', 'UserController');
    

    #Encuestas
    Route::resource('surveys', 'SurveyController');


    #Preguntas
    Route::resource('surveys.questions', 'QuestionController');


    #Reportes
    Route::get('reports', 'ReportController@index')->name('reports');
    Route::get('reports/{company}/contacts', 'ReportController@get_company_contacts')->name('get_company_contacts');
    Route::get('reports/{company}/contracts', 'ReportController@get_company_contracts')->name('get_company_contracts');
    Route::get('reports/{company}/company_gears', 'ReportController@get_company_gears')->name('get_company_gears');
    Route::get('reports/{company}/coverages', 'ReportController@get_company_coverages')->name('get_company_coverages');
    Route::post('reports/get_report', 'ReportController@get_report')->name('get_report');



    #Proyectos por compania
    Route::resource('companies.projects', 'CompanyProjectController');
    Route::post('companies/{company}/projects/{project}/project_ticket', 'ProjectController@project_ticket')->name('new-project-ticket');

    #Proyectos general
    Route::resource('projects', 'ProjectController');
    Route::get('project/details', 'ProjectController@project_details')->name('project_details');
    Route::post('project/{project}/cancel', 'ProjectController@cancel_project')->name('cancel_project');
    Route::post('project/{project}/active', 'ProjectController@active_project')->name('active_project');

    #Inventario
    Route::resource('inventories', 'InventoryController');
    Route::resource('inventories.stock', 'StockController');
    Route::post('inventories/{inventory}/stock/{stock}/assign_company_to_gear', 'StockController@assign_gear_to_company')->name('assign_gear_to_company');

    #Cotizaciones
    Route::resource('companies.projects.quotations', 'QuotationController');
    Route::post('companies/{company}/projects/{project}/validate_quotation', 'QuotationController@validate_quotation')->name('validate_quotation');
});

laravel/app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;

class User extends Authenticatable
{
    use Notifiable;

    use SoftDeletes;

    protected $dates = ['deleted_at'];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'first_name', 'last_name', 'email', 'password', 'role', 'username',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    public function agent()
    {

        return $this->hasOne('App\Agent', 'user_id', 'id');

    }

    public function zones()
    {

        return $this->hasMany('App\ZoneUser', 'user_id', 'id');

    }

    public function contact()
    {

        return $this->hasOne('App\CompanyUser', 'user_id', 'id');

    }

    public function getFullNameAttribute()
    {

        return "{$this->first_name} {$this->last_name}";

    }

    public function companies()
    {

        #coleccion de compañias
        $companies = collect([]);
        
        #se verifica que una compañia se agregue solo una vez
        $zones = collect([]);

        $this->zones->each(function($zone) use ($companies, $zones) {
            collect($zone->company->all_childs())->each(function($zone) use ($companies, $zones) {

                if(!in_array($zone->id, $zones->toArray())){
                    
                    $zones->push($zone->id);
                    $companies->push($zone);

                }

            });
        });

        return $companies;
    }

    public function getAgentIsSupervisorAttribute()
    {
        $result = false;

        if ( isset( $this->agent ) ) {
            
            if ( optional( $this->agent->department )->supervisor_id == $this->agent->id ) {
                
                $result = $this->agent->department;

            }

        }

        return $result;
    }

    public function getAgentAsManagerAttribute()
    {
        $result = false;

        if ( isset( $this->agent ) ) {
            if ( $this->agent->as_manager ) {
                $result = true;
            }
        }

        return $result;
    }

    public function getAgentsInGroupAttribute()
    {   
        $agents_in_groups = false;

        if ( isset( $this->agent ) ) {
            $groups = $this->agent->supervisor_in_groups;

            if($groups->count() > 0){

                $agents_in_groups = [];

                foreach($groups as $group){
                    
                    if ($agents = $group->agents()->count() > 0) {

                        $agents = $group->agents()->with('agent')->get()->pluck('agent.id');

                        foreach($agents as $agent){

                            if( ! in_array($agent, $agents_in_groups)){

                                array_push($agents_in_groups, $agent); 

                            }
                        }
                    }
                }
            }
        }

        return $agents_in_groups;
    }

    public function getZonesFromContactTypeAttribute()
    {
        $ids = false;
        if ( isset( $this->contact ) ) {

            foreach ($this->zones as $zone) {

                $ids[$zone->company->id] = $zone->company->id;
                #se obtendran las companias de las zonas
                if (optional($zone->company)->id) {
                    #se obtendran los hijos de la compania si son de contacto principal
                    if ($zone->role == 'Contacto Principal') {

                        $company_childs = $zone->company->all_childs();

                    } else {

                        $company_childs = $zone->company->childs;

                    }

                    if (count($company_childs) > 0) {

                        foreach ($company_childs as $company_child) {

                            $ids[$company_child->id] = $company_child->id;
                        }

                    }
                }
            }
        }

        return $ids;
    }

    public function tickets_contact()
    {
        return $this->hasMany('App\Ticket', 'contact_id', 'id');
    }
}

laravel/resources/views/helpdesk/tickets/create.blade.php
@extends('layouts.master')
@section('content')

<div class="container">
	<div class="card">
		<div class="card-header">
			<div class="row">
				<div class="col-sm-9 ml-auto">
					<p class="lead">
					
						<img src="{{ asset('img/iconos/tickets.svg') }}" style="height: 40px;" class="mr-2" alt="">

						Nuevo Ticket

					</p>
				</div>
			</div>
		</div>
		
		<div class="card-body" id="tickets_app">
	
			<div class="form-row">
				<div class="col-sm-9 ml-auto">
					<p>Campos requeridos marcados con <span class="text-danger">(*)</span></p>
				</div>
			</div>


			<form action="{{ route('tickets.store') }}" method="post" id="newTicketForm">
				{{ csrf_field() }}
				
				<div v-cloak>
					<div class="row form-row">
						<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
							<span class="text-danger">*</span>
							Compañia:
						</label>
						<div class="form-group col-sm-4">
							<select name="company_id" id="company_master_select" class="form-control" @change="get_company_gears_models" required>
								<option disabled selected value>Elige una compañia</option>
								@foreach($companies as $company)
									
									<option value="{{ $company->id }}">{{ $company->name }}</option>

								@endforeach
							</select>
						</div>
					</div>
			
					
					@role('admin', 'manager', 'agent')


					<div class="row form-row" v-if=" zones ">
						<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
							
							Sitio:

						</label>
						<div class="form-group col-sm-4">
							<select name="zone_id" class="form-control" @change="get_zone_contacts">
								
								<option selected value>Elige un sitio (opcional)</option>

								<option v-for="zone in zones" :value="zone.id">@{{ zone.name }}</option>


							</select>
						</div>
					</div>
			

					<div class="row form-row" v-if=" contacts.length > 0 ">
						<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
							
							<span class="text-danger">*</span>
							
							Contacto:

						</label>
						<div class="form-group col-sm-4">
							<select name="contact_id" class="form-control" required>
								<option disabled selected value>Elige un contacto</option>
								<option v-for="contact in contacts" :value="contact.contact.user.id">@{{ contact.contact.user.first_name + ' ' + contact.contact.user.last_name }}</option>
							</select>
						</div>
					</div>

					@endrole
					
					<div class="row form-row mb-3" v-if="search_models">
						<div class="col-sm-9 ml-auto d-flex align-items-center">
							<i class="fa fa-spin fa-spinner mr-2"></i> 
							<span>Cargando Información</span>
						</div>
					</div>
					
					<div class="form-row" v-if="models.length > 0">
						<div class="col-sm-9 ml-auto">
							<p class="text-info">Elige un equipo relacionado a tu requerimiento en caso de ser necesario</p>
						</div>
					</div>

					<div class="row form-row" v-if="models.length > 0">
						<label for="" class="col-form-label col-sm-3 text-right">Modelo:</label>
						<div class="form-group col-sm-4">
							<select name="model_id" class="form-control" @change="get_serial_numbers">
								<option selected value>Elige un modelo</option>
								<option v-for="model in models" :value="model.id">@{{ model.name }}</option>
							</select>
						</div>
					</div>

					<div class="row form-row mb-3" v-if="search_serial_numbers">
						<div class="col-sm-9 ml-auto d-flex align-items-center">
							<i class="fa fa-spin fa-spinner fa-2x mr-2"></i> 
							<span>Cargando Equipos</span>
						</div>
					</div>

					<div class="row form-row" v-if="gears.length > 0">
						<label for="" class="col-form-label col-sm-3 text-right"><span class="text-danger">*</span> Equipo:</label>
						<div class="form-group col-sm-6">
							<select name="gear_id" class="form-control" required>
								<option selected value>Elige un equipo</option>
								<option v-for="gear in gears" :value="gear.id">@{{ gear.serial_number }}</option>
							</select>
						</div>
					</div>

				</div>
				
				<div class="row form-row">
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						<span class="text-danger">*</span> Asunto:
					</label>
					<div class="form-group col-sm-6">
						<input type="text" name="subject" class="form-control" value="{{ old('subject') }}" autofocus required>
					</div>
				</div>

				<div class="row form-row">
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						<span class="text-danger">*</span> Descripción:
					</label>
					<div class="form-group col-sm-6">
						<textarea name="description" class="form-control" rows="5" required>{{ old('description') }}</textarea>
					</div>
				</div>
				
				<div class="row form-row">
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						<span class="text-danger">*</span> Severidad:
					</label>
					<div class="form-group col-sm-4">
						<select v-if="urgent_tickets" name="severity_id" class="form-control" value="{{ old('severity_id') }}" required>
							@foreach(App\Severity::get() as $severity)
								<option value="{{ $severity->id }}" {{ $severity->name == 'Normal' ? 'selected' : '' }}>{{ $severity->name }}</option>
							@endforeach
						</select>
						<select v-else name="severity_id" class="form-control" value="{{ old('severity_id') }}" required>
							@foreach(App\Severity::where('name', '<>', 'Urgente')->get() as $severity)
								<option value="{{ $severity->id }}" {{ $severity->name == 'Normal' ? 'selected' : '' }}>{{ $severity->name }}</option>
							@endforeach
						</select>
					</div>
				</div>

				<div class="row form-row">
				@role('admin','manager','agent')
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						<span class="text-danger">*</span> Categoría 1:
					</label>
					<div class="form-group col-sm-4 mb-3">
						<select name="category_id" id="parent" class="form-control" @change="get_category_son('a')" required>
				@else
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						<span class="text-danger">*</span> Categoría:
					</label>
					<div class="form-group col-sm-4 mb-3">
						<select name="category_id" id="parent" class="form-control" required>
				@endrole
							<option disabled selected value>Elige una opción</option>
							@foreach(App\Category::whereNull('parent_id')->get() as $category)
								<option value="{{ $category->id }}">{{ $category->name }}</option>
							@endforeach
						</select>
					</div>
				</div>

				<div class="row form-row" v-if="sub_categories_a.length > 0">
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						Categoría 2:
					</label>
					<div class="form-group col-sm-4 mb-3" v-cloak>
						<select name="category_id" id="sub_category_a" class="form-control" @change="get_category_son('b')">
							<option disabled selected value>Elige una opción</option>
							<option v-for="category in sub_categories_a" :value="category.id">@{{ category.name }}</option>
						</select>
					</div>
				</div>

				<div class="row form-row" v-if="sub_categories_b.length > 0">
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						Categoría 3:
					</label>
					<div class="form-group col-sm-4 mb-3" v-cloak>
						<select name="category_id" id="sub_category_b" class="form-control" @change="get_category_son('c')">
							<option disabled selected value>Elige una opción</option>
							<option v-for="category in sub_categories_b" :value="category.id">@{{ category.name }}</option>
						</select>
					</div>
				</div>

				<div class="row form-row" v-if="sub_categories_c.length > 0">
					<label for="" class="col-form-label col-sm-3 text-left text-sm-right">
						Categoría 4:
					</label>
					<div class="form-group col-sm-4 mb-3" v-cloak>
						<select name="category_id" id="sub_category_c" class="form-control">
							<option disabled selected value>Elige una opción</option>
							<option v-for="category in sub_categories_c" :value="category.id">@{{ category.name }}</option>
						</select>
					</div>
				</div>

				<div class="row form-row mb-3" v-if="search_categories">
					<div class="col-sm-9 ml-auto d-flex align-items-center">
						<i class="fa fa-spin fa-spinner mr-2"></i> 
						<span>Cargando Información</span>
					</div>
				</div>
			</form>

		</div>

		<div class="card-footer">
			<div class="row form-row">
				<div class="col-sm-9 ml-auto">
					<button type="submit" form="newTicketForm" class="btn btn-success"><i class="fa fa-paper-plane"></i> Enviar Ticket</button>
				</div>
			</div>
		</div>
	</div>
</div>

@stop

@section('scripts')
	
	<script src="{{ asset('js/vue.js') }}"></script>
	<script>
		var ticketApp = new Vue({

			el: '#tickets_app',

			data: {

				search_models     	  : false,
				search_categories 	  : false,
				contacts 		  	  : [],
				zones 			  	  : null,
				models 			  	  : [],
				no_models 		  	  : false,
				search_serial_numbers : false,
				gears 				  : [],
				sub_categories_a 	  : [],
				sub_categories_b      : [],
				sub_categories_c 	  : [],
				urgent_tickets 		  : false
			},

			methods: {

				get_company_gears_models: function(e){

					var t = this;

					var select = $(e.target);

					var company = select.val();

					var url = '{{ route('companies.gears.index', '#company_id') }}';

					url = url.replace('#company_id', company);

					t.search_models = true;

					t.no_models = false;

					t.models = [];

					t.gears = [];

					t.contacts = [];

					t.zones = null;

					$.get(url, function(response){

						t.contacts = response.contacts;

						t.zones = response.zones;

						t.models = response.models;

						t.urgent_tickets = response.urgent_tickets ? true : false;

						t.gears = [];

						t.search_models = false;

						if(t.models.length == 0){
							t.no_models = true;
						}

					});

				},



				get_zone_contacts: function(e){


					var t = this;

					var select = $(e.target);

					var zone = select.val();

					var route = "{{ route('get_zone_contacts', '#zone_id') }}";


					if(zone){


						route = route.replace('#zone_id', zone);

						
					}else{


						var master_company = $('#company_master_select').val();


						route = route.replace('#zone_id', master_company);


					}


					t.contacts = [];

					t.models = [];

					t.gears = [];

					t.urgent_tickets = false;


					$.getJSON(route, function(response){

						t.contacts = response.contacts;

						t.models = response.models;

						t.urgent_tickets = response.urgent_tickets ? true : false;

					});


				},


				get_serial_numbers: function(){

					var t = this;

					var select = $(event.prevent);

					var value = select.val();

					var company_id = $('[name="company_id"]').val();

					var zone_id = $('[name="zone_id"]').val();

					var model_id = $('[name="model_id"]').val();

					var url = '{{ route("get_gears_by_model", ["#company_id", "#model_id"]) }}';


					if(zone_id){

						url = url.replace('#company_id', zone_id).replace('#model_id', model_id);
						
					}else{

						url = url.replace('#company_id', company_id).replace('#model_id', model_id);

					}


					t.search_serial_numbers = true;


					if(model_id){

						$.get(url, function(response){

							t.gears = response;

							t.search_serial_numbers = false;

							select.val($("option:first", select).val());

						});

					}else{

						t.search_serial_numbers = false;

						t.gears = [];

					}


				},

				get_category_son: function(level){

					var t      = this
					var url    = '{{ route('category.subcategory.index', ['category' => '#category']) }}'
					var parent = null

					
					if (level == 'a') {
						parent = $('#parent').val()

						t.sub_categories_a = []
						t.sub_categories_b = []

						$('#sub_category_a').val('')
						$('#sub_category_b').val('')
						$('#sub_category_c').val('')

						url = url.replace('#category', parent)

						t.search_categories = true;
					} else if ( level == 'b') {
						parent = $('#sub_category_a').val()

						t.sub_categories_c = []
						
						$('#sub_category_b').val('')
						$('#sub_category_c').val('')

						url = url.replace('#category', parent)

						t.search_categories = true;
					} else if ( level == 'c') {
						parent = $('#sub_category_b').val()
						
						$('#sub_category_c').val('')

						url = url.replace('#category', parent)
					}
					
					$.get(url, function(response){
						t.search_categories = false;
						if (level == 'a') {
							t.sub_categories_a = response
						} else if ( level == 'b') {
							t.sub_categories_b = response
						} else if ( level == 'c') {
							t.sub_categories_c = response
						}
					})
				}

			}

		});
	</script>

@stop

laravel/resources/views/helpdesk/tickets/show.blade.php
@extends('layouts.master')

@section('content')


	<div class="container" id="task">
		<div class="card">
			<div class="card-header d-flex align-items-center">
				<p class="lead text-danger">#{{ $ticket->ticket_id }} @if ($ticket->deleted_at) - Archivado @endif</p>
				@role('admin', 'manager', 'agent')
				<form action="{{ route('export_ticket_to_pdf', $ticket->ticket_id) }}/" method="post" class="ml-auto">
					{{ csrf_field() }}
					<button type="submit" class="btn btn-light" data-toggle="tooltip" data-placement="left" title="Descarga en PDF la actividad del ticket #{{ $ticket->ticket_id }}">
						<i class="fa fa-download"></i> Descargar
					</button>
				</form>
				@endrole
			</div>
			<div class="card-body">
				@include('helpdesk.tickets.html.company_information')
				@include('helpdesk.tickets.html.ticket_description')
			</div>
		</div>
		@include('helpdesk.tickets.html.tabs')
		@include('helpdesk.tickets.partials.modal-public-comment')
		@include('helpdesk.tickets.partials.modal-public-resolve-comment')

		@role('admin', 'manager', 'agent')
			@include('helpdesk.tickets.partials.modal-new-task')
			@include('helpdesk.tickets.partials.modal-update-task')
			@include('helpdesk.tickets.partials.modal-add-event-to-task')
		@endrole
		@role('agent')
			@include('helpdesk.tickets.partials.modal-reopen-ticket')
		@endrole
	</div>

@endsection

@section('scripts')

	<script type="text/javascript">
		var task_app = new Vue({
			el: '#task',
			data: {
				task: [],
				update_url: null,
				task_id: null,
				change_ticket_status_to_resolve: false,
			},
			mounted(){
			},
			methods: {
				minute_value: function(){
					var value = $('[name="minutes"]').val()
					if (value) {
						if ( value < 1 ) {
							$('[name="minutes"]').val(1)
						}
					}
				},

				active_success_btn: function(e){

					var select = $(e.target);

					var btn = select.closest('form').siblings('button');

					btn.removeAttr('disabled');

				},


				submit_comment: function(e){


					var form = $(e.target);


					var btn = $("button[form='new_comment_to_company_form']");


					var public_comment = $('#commentPublicCheckbox').val();


					if(public_comment == 1){


						var ask = confirm('¿Estas seguro que deseas hacer público este comentario?');


						if(ask){


							form.submit();

							
						}else{


							setTimeout(function(){


								btn.removeAttr('disabled');

							}, 150);
							


						}


					}else{


						form.submit();


					}


				},


				get_task( task_id ){
					var t = this;

	                var show_url = '{{ route('tickets.tasks.show', ['ticket'=>'#ticket_id', 'task' => '#task_id']) }}';
	                var update_url = '{{ route('tickets.tasks.update', ['ticket'=>'#ticket_id', 'task' => '#task_id']) }}';

	                show_url = show_url.replace( '#ticket_id', '{{ $ticket->ticket_id }}' );
	                show_url = show_url.replace( '#task_id', task_id );

	                update_url = update_url.replace( '#ticket_id', '{{ $ticket->ticket_id }}' );
	                update_url = update_url.replace( '#task_id', task_id );

	                t.$http.get(show_url).then(function(response){
	                    t.task = response.body;

	                    t.update_url = update_url;

	                    $('#update_task_modal').modal('show')
	                });
				},


				add_event_to_task: function(task, ticket){

					var t = this;

					
					var modal = $('#add_event_to_task_modal');

					
					modal.modal('show');


					t.task_id = task;


					t.ticket_id = ticket;



				},


				comment_to_task_route: function(){


					var t = this;


					var route = "{{ route('tickets.tasks.events.store', ["#ticket_id", "#task_id"]) }}";

					
					route = route.replace('#ticket_id', t.ticket_id).replace('#task_id', t.task_id);


					return route;


				},
				change_status_ticket: function(){
					var t 					= this;
					var get_selected_status = $('[name="status_id"]').val();
					var get_status_id       = '{{ App\Status::where('name', 'Resuelto')->first()->id }}';

					if (get_selected_status == get_status_id) {

						t.change_ticket_status_to_resolve = true;

						$('#last_comment_to_company_ticket').modal('show')

					} else {

						$('#updateStatusForm').submit()
					}
				},
				send_last_event_ticket: function(e){
					var t 		  = 	this;
					var form 	  = 	$(e.target);
					var form_id   = 	form.attr('id');
					var data  	  = 	form.serializeArray();
					var url 	  = 	form.attr('action');

					data.push({ name: 'days', value: '0'});
					data.push({ name: 'hours', value: '0'});
					data.push({ name: 'minutes', value: '0'});
					data.push({ name: 'type', value: 1});
					data.push({ name: 'last_comment', value: 1});

					$.post(url, data, function(response){

						if (response.result) {
	                    	$('#updateStatusForm').submit();
						}

					});


				},
				skip_comment: function(){
					var t = this;

					$('#skip_comment_button').attr('disabled', true)

					if (t.change_ticket_status_to_resolve) {
						
		                $('#updateStatusForm').submit()

					}
				}

			}
		})
	</script>

@stop